"initlme" <-
function(vec.data=vec.data,I=I,Tp=Tp,R=R,K=K,model=model,gene.classe)
  {    
    vec.Tp<-rep(1:Tp,rep(R,Tp))
    vec.Tp<-rep(vec.Tp,I)
    vec.I<-rep(1:I,rep(R*Tp,I))    
    #vec.IT<-rep(1:(I*Tp),rep(R,I*Tp))
    
    prop.init<-unlist(lapply(gene.classe,length))/sum(unlist(lapply(gene.classe,length)))   
    resl2m<-list(NULL)

    for(k in 1:K)
      {        
        numk<-gene.classe[[k]]
        # In numk, there is the numeros of the genes in the cluster k
        indk<-which(vec.I%in%numk)
        nk<-length(numk)        
        kvec.data<-vec.data[indk]
        kvec.Tp<-vec.Tp[indk]
        kvec.I<-rep(1:nk,rep(R*Tp,nk))
        kvec.IT<-rep(1:(nk*Tp),rep(R,nk*Tp))

        
        switch(model,
               "E0.M1"={resl2m<-NULL},
               "E0.M3"={resl2m<-NULL},
               
               "E1.M1"={resl2m[[k]]<- lme(kvec.data~as.factor(kvec.Tp)-1, random=~1|kvec.I) },
               "E1.M2"={resl2m[[k]]<- lme(kvec.data~as.factor(kvec.Tp)-1, random=~1|kvec.I) },
               "E1.M3"={resl2m[[k]]<- lme(kvec.data~as.factor(kvec.Tp)-1, random=~1|kvec.I) },

               "E2.M1"={resl2m[[k]]<- lme(kvec.data~as.factor(kvec.Tp)-1, random=~1|kvec.IT) },
               "E2.M2"={resl2m[[k]]<- lme(kvec.data~as.factor(kvec.Tp)-1, random=~1|kvec.IT) },
               "E2.M3"={resl2m[[k]]<- lme(kvec.data~as.factor(kvec.Tp)-1, random=~1|kvec.IT) },

               "E3.M1"={resl2m[[k]]<- lme(kvec.data~as.factor(kvec.Tp)-1, random=~1|kvec.I/kvec.IT) },
               "E3.M2"={resl2m[[k]]<- lme(kvec.data~as.factor(kvec.Tp)-1, random=~1|kvec.I/kvec.IT) },
               "E3.M3"={resl2m[[k]]<- lme(kvec.data~as.factor(kvec.Tp)-1, random=~1|kvec.I/kvec.IT) }
               )
      }
    
    mean.init<-matrix(0,nrow=Tp,ncol=K)
    if(model!="E0.M1" & model!="E0.M3")
      {
        for(k in 1:K)       
          mean.init[,k]<-resl2m[[k]]$coefficients$fixed          
      }    
    #mean.init<-t(means.centers)
       
    switch(model,
    ##### E0 case       
           "E0.M1"=
           {
             sigma2.init<-var(vec.data)
             tau2.init<-NULL
           },
           "E0.M3"=
           {
             sigma2.init<-NULL
             for(k in 1:K)
               {
                 numk<-gene.classe[[k]]
                 # In numk, there is the numeros of the genes in the cluster k
                 indk<-which(vec.I%in%numk)
                 kvec.data<-vec.data[indk]
                 sigma2.init<-c(sigma2.init,var(kvec.data))
               }
             tau2.init<-NULL  
             
           },
           
  #### E1 case              
           "E1.M1"=
           {
             tau2<-NULL
             sigma2<-NULL
             for(k in 1:K)
               {
                 tau2<-c(tau2,as.numeric(VarCorr(resl2m[[k]])[1,"Variance"]))
                 sigma2<-c(sigma2,resl2m[[k]]$sigma^2)
               }
             tau2.init<-mean(tau2)
             sigma2.init<-mean(sigma2)                       
           },
           "E1.M2"=
           {
             tau2<-rep(0,K)
             sigma2<-NULL
             for(k in 1:K)
               {
                 tau2[k]<-as.numeric(VarCorr(resl2m[[k]])[1,"Variance"])
                 sigma2<-c(sigma2,resl2m[[k]]$sigma^2)
               }
             tau2.init<-tau2
             sigma2.init<-mean(sigma2)
           },           
           "E1.M3"=
           {
             tau2<-rep(0,K)
             sigma2<-rep(0,K)
             for(k in 1:K)
               {
                 tau2[k]<-as.numeric(VarCorr(resl2m[[k]])[1,"Variance"])
                 sigma2[k]<-resl2m[[k]]$sigma^2
               }
             tau2.init<-tau2
             sigma2.init<-sigma2
           },

  #### E2 case
           "E2.M1"=
           {
            tau2<-NULL
             sigma2<-NULL
             for(k in 1:K)
               {
                 tau2<-c(tau2,as.numeric(VarCorr(resl2m[[k]])[1,"Variance"]))
                 sigma2<-c(sigma2,resl2m[[k]]$sigma^2)
               }
             tau2.init<-mean(tau2)
             sigma2.init<-mean(sigma2)               
           },
           "E2.M2"=
           {
             tau2<-rep(0,K)
             sigma2<-NULL
             for(k in 1:K)
               {
                 tau2[k]<-as.numeric(VarCorr(resl2m[[k]])[1,"Variance"])
                 sigma2<-c(sigma2,resl2m[[k]]$sigma^2)
               }
             tau2.init<-tau2
             sigma2.init<-mean(sigma2)
           },
           "E2.M3"=
           {
             tau2<-rep(0,K)
             sigma2<-rep(0,K)
             for(k in 1:K)
               {
                 tau2[k]<-as.numeric(VarCorr(resl2m[[k]])[1,"Variance"])
                 sigma2[k]<-resl2m[[k]]$sigma^2
               }
             tau2.init<-tau2
             sigma2.init<-sigma2             
           },
           
 ##### E3 case          
           "E3.M1"=
           {
            tau2<-NULL
            sigma2<-NULL
             for(k in 1:K)
               {
                 tau2<-cbind(tau2,as.numeric(VarCorr(resl2m[[k]])[c(2,4),"Variance"]))
                 sigma2<-c(sigma2,resl2m[[k]]$sigma^2)
               }
            tau2.init<-as.matrix(apply(tau2,1,mean))%*%rep(1,K)
            sigma2.init<-mean(sigma2) 
           },

           "E3.M2"=
           {
            tau2<-matrix(0,ncol=K,nrow=2)
            sigma2<-NULL
             for(k in 1:K)
               {
                 tau2[,k]<-as.numeric(VarCorr(resl2m[[k]])[c(2,4),"Variance"])
                 sigma2<-c(sigma2,resl2m[[k]]$sigma^2)
               }
             tau2.init<-tau2
             sigma2.init<-mean(sigma2) 
           },
           "E3.M3"=
           {
             tau2<-matrix(0,ncol=K,nrow=2)
             sigma2<-rep(0,K)
             for(k in 1:K)
               {
                 tau2[,k]<-as.numeric(VarCorr(resl2m[[k]])[c(2,4),"Variance"])
                 sigma2[k]<-resl2m[[k]]$sigma^2
               }
             tau2.init<-tau2
             sigma2.init<-sigma2
           }
           )
   invisible(list(prop.init=prop.init,mean.init=mean.init,tau2.init=tau2.init,sigma2.init=sigma2.init,resl2m=resl2m)) 
  }
