"l3m" <-
function(data,K=2,model,impres=1,iter.em=150,eps=0.0001,init="em",param.init=NULL,iter.em.init=30)
  {
    
    require(mvtnorm) ||stop("The library mvtnorm is not installed")
    require(mva) ||stop("The library mva is not installed")
    require(nls) ||stop("The library nls is not installed")
    require(nlme) ||stop("The library nlme is not installed")
    
    model<-model
    iter.em.init<-iter.em.init
    eps<-eps
    name.data<-deparse(substitute(data))

    data<-data
    #I<-dim(data)[1]
    #Tp<-dim(data)[2]
    #R<-dim(data)[3]
    K<-K
    impres<-impres
    iter.em<-iter.em
     
    #resinit<-initl3m(data=data,K=K,model=model,init=init)
    if(is.null(param.init))
      {
        if(impres!=0)
          cat("\nInitialisation parameters. \n")   
        resinit<-init2(data=data,K=K,model=model,init=init,iter.em.init=iter.em.init)
          
        prop.init<-resinit$prop.init
        mean.init<-resinit$mean.init
        if(model !="E0.M1" & model !="E0.M3")
          tau2.init<-resinit$tau2.init
        sigma2.init<-resinit$sigma2.init
        if(impres!=0)
          cat("Initialisation parameters completed. \n \n")
    
      }
    
    if(!is.null(param.init))
      {
       prop.init<-param.init$prop.theta
       mean.init<-param.init$mean.theta
       if(model !="E0.M1" & model !="E0.M3")
          tau2.init<-param.init$tau2.theta
        sigma2.init<-param.init$sigma2.theta
      }
    
    switch(model,
           "E0.M1"={res<-estiml3m.E0.M1(data=data,K=K,prop.init=prop.init,mean.init=mean.init,sigma2.init=sigma2.init,iter.em=iter.em,
                                        impres=impres,name.data=name.data,eps=eps) },
           "E0.M3"={res<-estiml3m.E0.M3(data=data,K=K,prop.init=prop.init,mean.init=mean.init,sigma2.init=sigma2.init,iter.em=iter.em,
                                        impres=impres,name.data=name.data,eps=eps) },
           
           "E1.M1"={res<-estiml3m.E1.M1(data=data,K=K,prop.init=prop.init,mean.init=mean.init,tau2.init=tau2.init,sigma2.init=sigma2.init,
                                        iter.em=iter.em,impres=impres,name.data=name.data,eps=eps) },
           "E1.M2"={res<-estiml3m.E1.M2(data=data,K=K,prop.init=prop.init,mean.init=mean.init,tau2.init=tau2.init,sigma2.init=sigma2.init,
                                        iter.em=iter.em,impres=impres,name.data=name.data,eps=eps) },
           "E1.M3"={res<-estiml3m.E1.M3(data=data,K=K,prop.init=prop.init,mean.init=mean.init,tau2.init=tau2.init,sigma2.init=sigma2.init,
                                        iter.em=iter.em,impres=impres,name.data=name.data,eps=eps) },
           
           "E2.M1"={res<-estiml3m.E2.M1(data=data,K=K,prop.init=prop.init,mean.init=mean.init,tau2.init=tau2.init,sigma2.init=sigma2.init,
                                        iter.em=iter.em,impres=impres,name.data=name.data,eps=eps) },
           "E2.M2"={res<-estiml3m.E2.M2(data=data,K=K,prop.init=prop.init,mean.init=mean.init,tau2.init=tau2.init,sigma2.init=sigma2.init,
                                        iter.em=iter.em,impres=impres,name.data=name.data,eps=eps) },
           "E2.M3"={res<-estiml3m.E2.M3(data=data,K=K,prop.init=prop.init,mean.init=mean.init,tau2.init=tau2.init,sigma2.init=sigma2.init,
                                        iter.em=iter.em,impres=impres,name.data=name.data,eps=eps) },
           
           "E3.M1"={res<-estiml3m.E3.M1(data=data,K=K,prop.init=prop.init,mean.init=mean.init,tau2.init=tau2.init,sigma2.init=sigma2.init,
                                        iter.em=iter.em,impres=impres,name.data=name.data,eps=eps) },
           "E3.M2"={res<-estiml3m.E3.M2(data=data,K=K,prop.init=prop.init,mean.init=mean.init,tau2.init=tau2.init,sigma2.init=sigma2.init,
                                        iter.em=iter.em,impres=impres,name.data=name.data,eps=eps) },
           "E3.M3"={res<-estiml3m.E3.M3(data=data,K=K,prop.init=prop.init,mean.init=mean.init,tau2.init=tau2.init,sigma2.init=sigma2.init,
                                        iter.em=iter.em,impres=impres,name.data=name.data,eps=eps) }
           )
    if(impres!=0)
      summaryl3m(res)
    
    invisible(res)
    

  }
