"summaryl3m" <-
function(listl3m,printout=T)
  {


    if(is.null(listl3m))
      {
        if(printout)
          cat(paste(" (Warning : ",deparse(substitute(listl3m))," is NULL)\n",sep=""))
        invisible(NA)        
      }
    else
      {
        Tp<-dim(listl3m$mean.theta)[1]
        K<-dim(listl3m$mean.theta)[2]
        I<-dim(listl3m$mat.fik)[1]
        model<-listl3m$model
        param<-paraml3m(model,K=K,Tp=Tp)
    

       #Log-likelihood
        mat.propfik<-listl3m$mat.fik%*%diag(listl3m$prop.theta)
        tmp<-apply(mat.propfik,1,sum)
        tmp<-log(tmp)        
        loglik<-sum(tmp,na.rm=T)

       #BIC
        BIC<--2*loglik+param*log(I)
    
       #AIC
        AIC<--2*loglik+2*param

       #ICL
        tmp<-partitionl3m(mat.fik=listl3m$mat.fik,prop.theta=listl3m$prop.theta)
        z<-tmp$z
        mat.tik<-tmp$mat.tik
        ICL<--2*loglik - 2*sum(z*log(mat.tik),na.rm=T) +param*log(I)

  
    
        if(printout)
          {
            cat("\n")
    
            cat("Data Informations : \n")
            cat("------------------  \n")
            cat(paste("\t           Data : ",as.character(listl3m$name.data),"\n",sep=""))
            cat("\n")
        
            cat("Clustering Model :",listl3m$model, " with K=",dim(listl3m$mean.theta)[2]," classes. \n")
            cat("----------------- \n")
            cat("\n")

            cat("Model Informations :\n")
            cat("------------------- \n")
            cat(paste("\t Log-likelihood = ",round(loglik,4),"\n",sep=""))
            cat(paste("\t            BIC = ",round(BIC,4),"\n",sep=""))
            cat(paste("\t            AIC = ",round(AIC,4),"\n",sep=""))
            cat(paste("\t            ICL = ",round(ICL,4),"\n",sep=""))
            cat("\n")
        
            cat("Clustering Informations :\n")
        cat("------------------------ \n")
            cat(paste(gsub(",","",c("              classes proportions :",paste(round(listl3m$prop.theta,3),"  ",sep="")))),"\n")
            if(model!="E0.M1" & model !="E0.M3")
              {
                if(!is.matrix(listl3m$tau2.theta))
                  cat(paste(gsub(",","",c("           random effect variance :",round(listl3m$tau2.theta,3)))),"\n")
                if(is.matrix(listl3m$tau2.theta))
                  {
                    cat("           random effect variance :",paste("cl.",1:K,"   ",sep=""),"\n")
                    for(i in 1:dim(listl3m$tau2.theta)[1])
                    # cat(paste(gsub(",","",c("                                   ",round(listl3m$tau2.theta[i,],3),"   ",sep="   "))),"\n")
                      cat("                                   ",paste(format(round(listl3m$tau2.theta[i,],3),digits=3),"  ",sep=""),"\n")    
                  }
              }
        
            cat(paste(gsub(",","",c("           error measure variance :",paste(format(round(listl3m$sigma2.theta,3),digits=3),"  ",sep="")))),"\n")
            #cat("                                   ",paste(format(round(listl3m$sigma2.theta,3),digits=3),"  ",sep=""),"\n")  
            
            #mat.meanf<-format(round(listl3m$mean.theta,3),digits=3)
            #dimnames(mat.meanf)<-list(rep("",Tp),paste("cl.",1:K,"   ",sep=""))
            #cat("   (fixed effect) classes centers :\n")
            #cat(mat.meanf)
            #cat(" \n")
            cat("   (fixed effect) classes centers :",paste("cl.",1:K,"    ",sep=""),"\n")
            for(i in 1:Tp)
              {
                cat("                                  ",paste(format(round(listl3m$mean.theta[i,],3),digits=3),"  ",sep=""),"\n")    
              }
          }
        invisible(c(loglik=loglik,BIC=BIC,ICL=ICL,AIC=AIC) )
      }
  }
