\name{partitionl3m}

\alias{partitionl3m}

\title{Clustering from mixture of linear mixed models.}

\description{
 The function \code{l3m} provides a clustering from a mixture of linear
 mixed models.
}

\usage{
partitionl3m(mat.fik,prop.theta,resl3m=NULL)
}

\arguments{
 \item{mat.fik}{a matrix of dimension IxK which gives the density
      probabilities values for each statistic unit and each component of the mixture.}
 \item{prop.theta}{a vector for the proportion estimations of the mixture.}
  \item{resl3m}{a list that is the result from the l3m() program.}
}


\details{ the program needs either the two first arguments or either the last
  argument. 
}

\value{
  \item{z}{a matrix of dimension IxK. $z_{ik}$ is equal to 1 if the
    statistical unit belongs to the cluster $k$ and 0 otherwise.}
  \item{mat.tik}{a matrix of dimension IxK which gives the conditional probabilities
      that the statistical units belongs to the clusters. }
  \item{num.classe}{a vector of length I which gives the numero of the
    cluster for each statistical unit.}
}

\author{Martin Olivier, \email{martinol@ensam.inra.fr}}

\seealso{
  \code{\link{datal3m}}, \code{\link{l3m}}
}

\examples{
data(datal3m)

resl3m<-l3m(datal3m,K=3,model="E2.M3",init="em",iter.em.init=10,iter.em=50)
part<-partitionl3m(resl3m=resl3m)
part$num.classe

## You will see the result for the clustering from the mixture of mixed
## models E2.M3.  part$num.classe gives for each statistical unit the
## numero of its cluster
 
}

\keyword{manip}