\name{summaryl3m}

\alias{summaryl3m}

\title{Summary for parameter estimations and penalized likelihood criteria for mixture of linear mixed models.}

\description{
 The function \code{summaryl3m} provides a summary 
}

\usage{
summaryl3m(listl3m,printout=T)
}

\arguments{
 \item{listl3m}{a list that is the result from the l3m() program.}
 \item{printout}{a Boolean which specfies if a summary for parameter
   estimations is printed in the R console. By default, the value is True.}
}



\value{
  a vector which contains the log-likelihood and the three criteria AIC,
  BIC and ICL.
}

\author{Martin Olivier, \email{martinol@ensam.inra.fr}}

\seealso{
  \code{\link{datal3m}}, \code{\link{l3m}}
}

\examples{
data(datal3m)

resl3m<-l3m(datal3m,K=3,model="E2.M3",init="em",iter.em.init=10,iter.em=50)
res<-summaryl3m(resl3m)

## You will see the results for the estimation parameters
## for the model E2.M3

res
## In the object res, the log-likelihood for the model and the three
## criteria AIC, BIC and ICL have been stored.
}

\keyword{print}